-- Example using MATCH_RECOGNIZE
-- to list people in HR.EMPLOYEES table
-- by date hired along with a note saying
-- if there salary was lower or higher than
-- the previous person hired (null if the same)
--
set pagesize 200
--
SELECT
    substr(last_name || ', ' || first_name,1,22) name
   ,to_char(hire_date,'YYYY-MM-DD') hire_date
   ,salary
   ,paytrend "PAY_TREND"
FROM
    hr.employees MATCH_RECOGNIZE (
        ORDER BY hire_date
        MEASURES
            classifier() AS paytrend
        ALL ROWS PER MATCH
    PATTERN ( first* lower* higher*) DEFINE
        first AS ROWNUM = 1
       ,lower AS lower.salary < prev(salary)
       ,higher AS higher.salary > prev(salary)
    );