set echo on
--
-- Pattern matching - MATCH_RECOGNIZE
--    -- PARTITION BY / ORDER BY / PATTERN
select * from sh.sales
 match_recognize(
   partition by prod_id
   order by time_id
   measures strt.time_id as start_date,
   last(down.time_id) as bottom_date,
   last(up.time_id) as   end_date
   one row per match
   after match skip to last up
   pattern (strt down+ up+)
   define
     down as down.amount_sold < prev(down.amount_sold),
     up as up.amount_sold > prev(up.amount_sold)
   ) matcher
where prod_id = 120
order by matcher.prod_id, matcher.start_date;
--
select * from (select prod_id,trunc(time_id) time_id,sum(amount_sold) amount_sold from sh.sales where prod_id = 120 and extract(year from time_id) in (2000,2001) group by prod_id, trunc(time_id))
 match_recognize (
   partition by prod_id
   order by time_id
   measures to_char(strt.time_id,'yyyy-mm-dd') as start_date,
            to_char(last(down.time_id),'yyyy-mm-dd') as bottom_date,
            to_char(last(up.time_id) ,'yyyy-mm-dd') as   end_date,
            last(round(down.amount_sold)) as bottom_amt,
            last(round(up.amount_sold)) as end_amt
   --one row per match
   after match skip to last up
   pattern (strt down+ up+)
   define
     down as down.amount_sold < prev(down.amount_sold),
     up as up.amount_sold > prev(up.amount_sold)
   ) matcher
order by matcher.prod_id, matcher.start_date;
--
