-- Oracle 12.2 - PL/SQL Code Coverage
--
-- create coverage tables (one time)
exec dbms_plsql_code_coverage.create_coverage_tables;
--
--
-- before each test; start_coverage (provide label value)
declare
  testid number;
begin
  testid := dbms_plsql_code_coverage.start_coverage('MYTEST');
  dbms_output.put_line('MYTEST testid=' || testid);
end;
/
--
--  test PL/SQL here...
--
DECLARE
  IN_EMPNO NUMBER;
  IN_ENAME VARCHAR2(10);
  IN_JOB VARCHAR2(9);
  IN_SAL NUMBER;
  IN_COMM NUMBER;
  IN_DEPTNO NUMBER;
  RETURN_VAL NUMBER;
BEGIN
  IN_EMPNO := 8112;
  IN_ENAME := 'TEST';
  IN_JOB := 'TESTJOB';
  IN_SAL := 8000;
  IN_COMM := 90;
  IN_DEPTNO := 40;
  RETURN_VAL := NULL;

  BUILD_NEW_EMPLOYEE(
    IN_EMPNO => IN_EMPNO,
    IN_ENAME => IN_ENAME,
    IN_JOB => IN_JOB,
    IN_SAL => IN_SAL,
    IN_COMM => IN_COMM,
    IN_DEPTNO => IN_DEPTNO,
    RETURN_VAL => RETURN_VAL
  );
  DBMS_OUTPUT.PUT_LINE('RETURN_VAL = ' || RETURN_VAL);
 
END;
/
--
--
-- after PL/SQL code tested; stop_coverage
execute dbms_plsql_code_coverage.stop_coverage;
--
--
-- review code coverage data using label from start_coverage
select owner, name, type,
     round( ( sum(covered)/count(*) * 100), 2) pct_covered
  from dbmspcc_runs r
      join dbmspcc_units u
        on r.run_id = u.run_id
      join dbmspcc_blocks b
        on r.run_id = b.run_id
          and u.object_id = b.object_id
  where r.run_comment = 'MYTEST'
  group by owner, name, type;
  