set echo on
--
-- OFFSET rows (TOP-N queries)
--
-- Base query
--
-- 1st SELECT show all rows in native order
select ename,sal from emp order by sal desc;
--
-- 2nd SELECT uses ROWNUM, note first 5 rows (before sorting)
select ename,sal from emp
    where rownum < 5 order by sal desc;
--
--
select ename,sal from 
    (select ename,sal,rank() over (order by sal desc) as rank
       from emp) 
    where rank < 5;
--
-- Fetch top 5 rows NEW!
--
select ename,sal from emp
      order by sal desc
      fetch first 5 rows only;
--
-- OFFSET (Pagination)
--
select ename,sal from emp
   order by sal desc
   offset 2 rows  
   fetch first 5 rows only;
--
-- PERCENTAGE
--
select ename,sal from emp
   order by sal desc
   offset 2 rows  
   fetch first 5 percent rows only;
--
