-- Working with PL/SQL Result Cache
--
CREATE OR REPLACE FUNCTION RESULT_CACHE_TEST(
    in_cust_id sh.customers.cust_id%type,
    in_prod_id sh.sales.prod_id%type)
  RETURN NUMBER 
  -- RESULT_CACHE 
  authid current_user
AS
  sales NUMBER(7,0);
BEGIN
  SELECT COUNT(*) nbr_sales
    INTO sales
    FROM sh.customers cust JOIN sh.sales sales
            ON cust.cust_id    = sales.cust_id
    WHERE cust.cust_id = in_cust_id
      AND prod_id = in_prod_id;
  RETURN sales;
EXCEPTION
WHEN no_data_found THEN
  RETURN 0;
END RESULT_CACHE_TEST;
/
--
-- 2
set timing on  
select result_cache_test(462,19) from dual;
select result_cache_test(462,19) from dual;
select result_cache_test(462,19) from dual;
--
-- 3
CREATE OR REPLACE FUNCTION RESULT_CACHE_TEST(
    in_cust_id sh.customers.cust_id%type,
    in_prod_id sh.sales.prod_id%type)
  RETURN NUMBER 
  RESULT_CACHE 
  authid current_user
AS
  sales NUMBER(7,0);
BEGIN
  SELECT COUNT(*) nbr_sales
    INTO sales
    FROM sh.customers cust JOIN sh.sales sales
            ON cust.cust_id    = sales.cust_id
    WHERE cust.cust_id = in_cust_id
      AND prod_id = in_prod_id;
  RETURN sales;
EXCEPTION
WHEN no_data_found THEN
  RETURN 0;
END RESULT_CACHE_TEST;
/
--
-- 4
set timing on  
select result_cache_test(462,19) from dual;
select result_cache_test(462,19) from dual;
select result_cache_test(462,19) from dual;
