create or replace procedure build_new_employee
    (  in_empno in emp.empno%type
      ,in_ename in  emp.ename%type
      ,in_job in emp.job%type
      ,in_sal in emp.sal%type
      ,in_comm in emp.comm%type
      ,in_deptno in emp.deptno%type
      ,return_val in out number
  )
is
     emp_in_bonus boolean;
     emp_ename  emp.ename%type;
     bonus_ename  bonus.ename%type;
     bonus_sal    bonus.sal%type;
begin
     return_val := 0;
     begin
        select ename into emp_ename from emp
             where empno = in_empno;
        return_val := return_val + 1;
     exception
         when no_data_found
             then        
                insert into emp
                  (empno,ename,job,sal,comm,deptno)
                 values
                  (in_empno,in_ename,in_job,in_sal,in_comm,in_deptno);
                return_val := 0;
     end;
     begin
        select ename into bonus_ename from bonus
             where ename = emp_ename;
        return_val := return_val + 1;
     exception
        when no_data_found
            then
               insert into bonus
                (ename,job,sal,comm)
               values
                (in_ename,in_job,in_sal,in_comm);
     end;
 end;
/
